/*
 *
 * Format a 1541 disk from DOpus.
 *
 * (c) 1995 by Christer Bjarnemo  mr.bjarnemo@mn.medstroms.se
 *
 * Based on Twin-Dopus by Patrick Van Beem (patrick.van.beem@aobh.xs4all.nl),
 * which based he's script on the DOpusLhaARexx package by Geoff Seeley.
 *
 */

dircmd = "Work:Emulators/A64/Utils/"    /* Note. If the file ENVARC:1541.PREFS */
rxdir =  "Rexx:Dopus/1541/"             /* exists, that one will override the  */
tmpdir = "t:"                           /* settings here...                    */
DOpusPort   = 'DOPUS.1'

snuff = '22'x

if open(1,'env:1541.prefs','Read') then do
        dircmd = readln(1)
	rxdir  = readln(1)
        tmpdir = readln(1)
	address command 'type 'tmpdir'_64dir.tmp'
        end
close(1)

dircmd = slashpath(dircmd)
rxdir =  slashpath(rxdir)
tmpdir = slashpath(tmpdir)

if ~show(l,"rexxsupport.library") then        
    call addlib("rexxsupport.library",0,-30,0)
if showlist('Ports', DOpusPort) = 0 then do
   say 'Directory Opus Arexx port not found. Aborting.'
   call CleanUp
end

address(DOpusPort)
options results

/* setup DOpus window and tell user what's happening */
Busy on
TopText "Format a 1541-disk..."

Request 'Warning! You are going to FORMAT the disk in your 1541 diskdrive!'
if result = 0 then call cleanup

Getstring '"Enter a name for the 1541 disk" "Diskname,ID"'

dname = lower(result)

address command dircmd'64Cmd >'tmpdir'1541.tmp "n:'dname'" 8'

if open(1,tmpdir'1541.tmp','Read') then do
        Do for 8 ; tmp = readln(1) ; End
	say tmp
	Toptext tmp
        close(1)
        end
   address arexx rxdir'1541Dir.rexx'
exit

/*---------------------------------------------------------------------------*/

CleanUp: /* Remove any files and exit */
   Busy off
   exit
return


Lower: procedure /* Convert string to lowercase */
   parse arg string
   string = TRANSLATE(string, xrange('a', 'z'), xrange('A','Z'))
return string


/*---------------------------------------------------------------------------*/
Slashpath: procedure /* Put a (/) or (:) at the end of filenames (if neccessary) */
parse arg string
	if right(string,1) ~= ':' & right(string,1) ~= '/'  then do
		string = string'/'
		end
return string

